 /**
  * Zobrazovani a skryvani zalozek, oznaceni aktivni zalozky
  * zalozka - string zalozky, co se zobrazi
  * tab - int zalozky, ktera se oznaci jako aktivni    
  */ 
function zobraz_tab(zalozka,tab){
      
  var x = document.getElementsByClassName("tabs");
  for (var i = 0; i < x.length; i++) {
      if(zalozka != 'all'){
        x[i].classList.remove("w3-show");
        x[i].classList.add("w3-hide");   
      }else 
        x[i].classList.remove("w3-hide");      
  }
  if(zalozka != 'all')
    document.getElementById(zalozka).classList.remove("w3-hide");
    
  var zalozky = document.getElementsByClassName("w3-bar-item"); 
  for (var i = 0; i < zalozky.length; i++) {
      if(i==tab)
        zalozky[i].classList.add("active");  
      else
        zalozky[i].classList.remove("active");     
  }       
}        

/* modalni okna */
function show_modal(element){
  element.style.display='block';
}
  
function close_modal(element){
  element.style.display='none';
} 

/**
 * Zobrazovani a skryvani prvku.
 */ 
function show_hide(element){ 
  var item = document.getElementById(element);
  if(item.style.display == "none")
    item.style.display = "block";
  else
    item.style.display = "none";  
}   

function print_modal(element,trida,text=null){
    modal = document.getElementById(element);
    modal.innerHTML = "";
    var obal = document.createElement("div");
    obal.classList.add("w3-modal-content", "w3-animate-zoom", "w3-card-4",trida);
    //var header = document.createElement("header");
    //header.classList.add("w3-container");
    var zavreni = document.createElement("span");
    zavreni.classList.add("w3-button", "w3-display-topright", "modal-close");
    zavreni.addEventListener("click", function(){
      close_modal(modal)         
    });
    zavreni.innerHTML = "&times;";
        
    var datik = document.createElement("img");
    datik.alt="hodnoceni";
    
    var hlaska = document.createElement("h6");
    switch(trida){
      case "chyba": 
        datik.src= "image/vys_nok.png";
        if(text==null)
          text = random_string(1);  
      break;
      case "ok": 
        datik.src= "image/vys_ok.png";
        if(text==null)
          text = random_string(2);  
      break;
      case "neutr": 
        datik.src= "image/vys_neu.png";
      break;
    }       
   
    //obal.appendChild(header); 
        
    var obsah = document.createElement("div");
    obsah.appendChild(zavreni);
    
    let text_o = document.createElement("p");
    text_o.innerHTML = text;
    obsah.classList.add("w3-container");
    //obsah.innerHTML = "<p>"+text+"</p>";
    
    obsah.appendChild(datik);
    obsah.appendChild(text_o);
    obal.appendChild(obsah);
    modal.appendChild(obal);
    show_modal(modal);
}

/////////////////
//vraci string podle daneho parametru 1(NOK), 2(OK)
/////////////////
function random_string(typ){
  let int_r = Math.floor(Math.random() * 6);
  let ok_string = ["Sám bych to neudělal lépe!","Přesně takhle to má být!","Jo, to je správné řešení!","Dobře ty!","Uhodil jsi hřebíček na hlavičku!","Zvládl jsi to bezvadně!"];
  let nok_string = ["Něco mi na tom nesedí.","Ne, to nebude správně.","Zkus to ještě jednou.","Tohle nebude správné řešení.","Takhle to být nemá.","Nope, takhle to nemá být."];
  if(typ == 1){
    return nok_string[int_r];
  }else{
    return ok_string[int_r];
  }   
}

/* modalni okna konec */

/**
 * Pomocna fukce pro generovani cisel
 * Uziti: Sber papiru, adopce_zviratek 
 * Pro male rozdily, napr: (5,6) to vraci spatne udaje (vetsi jak max) -> pridan if 
 */ 
function random_int(min,max){
  var number = Math.round(Math.random() * max) + min;
  if(number > max) 
    number = max;
  return number;
}

function prohazej(co,kde){
  var prvky = document.getElementsByClassName(co);   
  var delka = prvky.length;
  var rodic = document.getElementsByClassName(kde);
  for(var i = 0; i < delka; i++){    
    var rand = random_int(0,delka-1);
    rodic[0].appendChild(prvky[rand]);
  }
}