var splneno = [[0,0,0],[0,0,0,0],[0,0]];                                        //pr3 ma [hlavicka, vse ostatni]
var pokusy = [0,0];    //[ok,nok]
var tmp_pomocna = [0,0]      //indikace zabrani hlavicek u pr3  [barva, zvire]

class navrh_tabulky{
    constructor(obtiznost){
    
    this.obtiznost = obtiznost;
    this.rodic = document.getElementById("pr_"+obtiznost);
    this.prefix = "image";      // /templates/PRIM/img/priklady/evidujeme_pr5
    
    this.navesti = new Array(5);
    this.navesti[0] = {"zkratka": "digi", "nazev": "Digitálky", "soubor": "digitalky"};
    this.navesti[1] = {"zkratka": "hodiny", "nazev": "Hodiny", "soubor": "hodiny"};
    this.navesti[2] = {"zkratka": "karta", "nazev": "Karty", "soubor": "karty"};
    this.navesti[3] = {"zkratka": "kostka", "nazev": "Kostky", "soubor": "kostky"};
    this.navesti[4] = {"zkratka": "lego", "nazev": "Lego", "soubor": "lego"};
    
    this.tmp = new Array(3);
    this.tmp["indexy"] = [0,1,2,3,4];               //pomocna promenna urcujici obrazky, co se budou vypisovat
    this.tmp["obrazky"] = [0,1,2,3,4,5];            //pomocna promenna urcujici poradi obrazku
    this.tmp["vypis"] = [0,1,2];                    //pomocna promennna urcujici vypisovani hromadek 
    this.razeni = Math.round(Math.random());        //urcuje razeni obrazku sestupně nebo vzestupne
    

    }
    
    //vytvori strukturu HTML 
    makeStructure(){
        //popis + img obal
        let popis_obal = document.createElement("div");
        popis_obal.classList.add("w3-threequarter");
        let ilustrace_obal = document.createElement("div");
        ilustrace_obal.classList.add("w3-quarter");
        let ilustrace = document.createElement("img");
        ilustrace.setAttribute("alt","Ilustrace");
        ilustrace.setAttribute("src",this.prefix+"/ilu_tvorbaTab.png");
        ilustrace_obal.appendChild(ilustrace);
        //popisek
        let popis_div = document.createElement("div");
        popis_div.classList.add("w3-row");
        popis_div.setAttribute("id","popis_"+this.obtiznost);
        let popis = document.createElement("p");
        let razeni;
        if(this.obtiznost == 1){            
            if(this.razeni == 1)    razeni = "od jedničky do šestky";
            else                    razeni = "od šestky do jedničky";
            popis.innerHTML = "<p>Vyzkoušej si vytvořit tabulku plnou obrázků. Podle názvů řádků vidíš, jaké druhy obrázků v&nbsp;tabulce budou. Od&nbsp;každého druhu máš za&nbsp;úkol do&nbsp;tabulky vložit šest obrázků.</p><p> Nejprve urči správně počet řádků a&nbsp;sloupců, které budou pro&nbsp;všechny obrázky potřeba. Až se Ti to&nbsp;povede, vykreslí&nbsp;se buňky a&nbsp;do&nbsp;nich budeš moci obrázky postupně přesouvat. Dej při umisťování obrázků pozor, aby byly v&nbsp;každém řádku seřazeny " + razeni +".</p>";      //od šestky do jedničky
        }else{
            if(this.razeni == 1)    razeni = "vzestupně";
            else                    razeni = "sestupně";
            popis.innerHTML = "<p>Máš za úkol vytvořit tabulku pro&nbsp;tři&nbsp;druhy obrázků. Každý druh bude zastoupen v&nbsp;jednom řádku obrázky, které odpovídají přirozeným číslům od&nbsp;jedničky do&nbsp;šestky.</p><p>Nejprve urči počet řádků a&nbsp;počet sloupců tabulky. Ve&nbsp;druhém kroku vyplň jejich záhlaví. Na&nbsp;pořadí názvů druhů obrázků nezáleží, ale pořadí čísel udělej " + razeni +". Na&nbsp;závěr naplň tabulku obrázky.</p>";            //vzestupně/sestupně
        }
        let help = document.createElement("sub");          
        help.innerHTML = "(Klinipto nápovědu)";
        var obtiznost = this.obtiznost;
        help.addEventListener("click", function(){
            show_hide('help_'+obtiznost);
        });
        
        let napoveda_text = document.createElement("p");
        napoveda_text.innerHTML = "Pokud máš doplňovat obrázky karet, eso (karta s písmenem A) představuje v takovém případě nejnižší hodnotou.";
        napoveda_text.classList.add('help');
        napoveda_text.setAttribute("id","help_"+this.obtiznost);
        napoveda_text.style.display = "none";
        
        popis_obal.appendChild(popis);            
        popis.appendChild(help);
        popis_obal.appendChild(napoveda_text);
        popis_div.appendChild(popis_obal); 
        popis_div.appendChild(ilustrace_obal); 
        //predelany kvuli ilustraci           
        this.rodic.appendChild(popis_div);     
        //div s tabulkou
        let obsah_obal = document.createElement("div");
        obsah_obal.classList.add("w3-row");
        
        let tabulka = document.createElement("div");
        tabulka.setAttribute("id","tabulka_"+this.obtiznost);
        tabulka.classList.add("w3-threequarter");
        
        let vyber_obr = document.createElement("div");
        vyber_obr.setAttribute("id","vyb_obr_"+this.obtiznost); 
        vyber_obr.classList.add("w3-quarter");
        
        //obtiznost 2 tam ma popisky tabulky
        if(this.obtiznost == 2){              
            let vyber_popisky = document.createElement("div");
            vyber_popisky.setAttribute("id","inputy_"+this.obtiznost);
            tabulka.appendChild(vyber_popisky);
        }                                                                                                              
        obsah_obal.appendChild(tabulka);
        obsah_obal.appendChild(vyber_obr);
        this.rodic.appendChild(obsah_obal);
    } 
    
    //dela nabidku obrazky
    vytvor_hromadky(pocet){
      let obal, element;
      let rodic = document.getElementById('vyb_obr_'+this.obtiznost);
      if(this.obtiznost == 2)
        rodic.style.display = "none";
      rodic.innerHTML = "";
      for(let i=0; i<pocet; i++){
        obal = document.createElement('div');
        this.prohazej('obrazky');                                             
        for(let x=0;x<this.tmp["obrazky"].length;x++){
          element = document.createElement('img');
          element.src = this.prefix+"/"+this.navesti[this.tmp["indexy"][this.tmp["vypis"][i]]]["soubor"]+"/"+this.navesti[this.tmp["indexy"][this.tmp["vypis"][i]]]["zkratka"]+""+(this.tmp["obrazky"][x]+1)+".jpg";
          element.dataset['id'] = this.navesti[this.tmp["indexy"][this.tmp["vypis"][i]]]["zkratka"]+""+(this.tmp["obrazky"][x]+1);
          element.dataset['index'] = this.tmp["vypis"][i];
          element.setAttribute("class","drag_pr"+this.obtiznost);
          obal.appendChild(element);
        }
        rodic.appendChild(obal);        
      }  
    }
    
    //vytvori popisky pro pr 2
    vytvor_popisky(){
        let vyber = document.createElement("div");
        vyber.setAttribute("id","vyber_pr"+this.obtiznost);
        vyber.classList.add("vyber_pr"+this.obtiznost);
        let umisteni = document.getElementById("tabulka_"+this.obtiznost);
        let span_ob;
        span_ob = document.createElement("span");
        span_ob.classList.add("drag_popisky");
        span_ob.innerHTML = "Název";       
        span_ob.dataset['id'] = "pop_poz_0";
        span_ob.dataset['index'] = 3;
        vyber.appendChild(span_ob);
        
        for(let i=1;i<7;i++){
            span_ob = document.createElement("span");  
            span_ob.classList.add("drag_popisky");
            span_ob.dataset['id'] = "pop_poz_"+i;  
            span_ob.dataset['index'] = 3;
            span_ob.innerHTML = i;
            vyber.appendChild(span_ob);
        }
        
        for(let i=0;i<3;i++){
            span_ob = document.createElement("span");
            span_ob.innerHTML = this.navesti[this.tmp["indexy"][this.tmp["vypis"][i]]]["nazev"];            
            span_ob.classList.add("drag_popisky");
            span_ob.dataset['id'] = "pop_vec";    
            span_ob.dataset['zkratka'] = this.navesti[this.tmp["indexy"][this.tmp["vypis"][i]]]["zkratka"];    
            span_ob.dataset['index'] = 3;
            vyber.appendChild(span_ob);
        }                       
        umisteni.appendChild(vyber);  
        
        //odkryju taky rovnou obrazy, co se budo pretahovat
        let rodic_ob = document.getElementById('vyb_obr_'+this.obtiznost);
        rodic_ob.style.display = "block";   
    }
    
    //dela nabidku inputy
    vytvor_inputy(){
        let obal, obal_p, obal_tb;        
        let pocet_sloupcu = document.createElement("input");
        pocet_sloupcu.setAttribute("type","number");          
        pocet_sloupcu.setAttribute("value","0");
        pocet_sloupcu.setAttribute("min","0");
        pocet_sloupcu.setAttribute("max","50");
        pocet_sloupcu.setAttribute("step","1");
        pocet_sloupcu.setAttribute("id","sloupce_"+this.obtiznost);
        pocet_sloupcu.classList.add("cap2");
        let pocet_radku = document.createElement("input");
        pocet_radku.setAttribute("type","number");
        pocet_radku.setAttribute("value","0");
        pocet_radku.setAttribute("min","0");
        pocet_radku.setAttribute("max","50");
        pocet_radku.setAttribute("step","1");
        pocet_radku.setAttribute("id","radky_"+this.obtiznost); 
        pocet_radku.classList.add("cap2");
        let tlac_ok = document.createElement("input");
        tlac_ok.setAttribute("type","submit");
        tlac_ok.classList.add("cap2");
            
        if(this.obtiznost == 1){
            tlac_ok.value = "Vyplnit tabulku";  
            obal_tb = document.getElementById("tabulka_in_pr"+this.obtiznost);
        }else if(this.obtiznost == 2){
            tlac_ok.value = "Vytvořit tabulku";
            obal_tb = document.getElementById("inputy_"+this.obtiznost);
        }else{
            //obt 3 rovnou skryje vse okolo 
            tlac_ok.value = "Vytvořit tabulku";
            obal_tb = document.getElementById("inputy_"+this.obtiznost);
            //TODO skryt okoli
            document.getElementById("evidujeme_pr3").style.display = "none";
            document.getElementById("vyber_pr3").style.display = "none";
            document.getElementById("vyb_obr_3").style.display = "none";
        }
        
        obal = document.createElement("div");
        obal_p = document.createElement("p");
        obal_p.style.display = "inline";
        obal_p.innerHTML = "Počet sloupců: ";
        obal.appendChild(obal_p);
        obal.appendChild(pocet_sloupcu);
        obal_tb.appendChild(obal);  
            
        obal = document.createElement("div");
        obal_p = document.createElement("p");
        obal_p.style.display = "inline";
        obal_p.innerHTML = "Počet řádků: ";
        obal.appendChild(obal_p);
        obal.appendChild(pocet_radku); 
        obal_tb.appendChild(obal);   
        
        var obtiznost = this.obtiznost;      
        tlac_ok.addEventListener("click", function(){
            vytvor_tabulku(obtiznost);
        });
        obal_tb.appendChild(tlac_ok);    
    }
    
    //vygeneruje tabulku    
    priprav_tab(){
        let radek, bunka;
        //pr1
        let tabulka = document.createElement("table");
        tabulka.setAttribute("id","evidujeme_pr"+this.obtiznost);
        tabulka.classList.add("navrh_tabulky");
        //"hlava"
        radek = document.createElement("tr");
        if(this.obtiznost == 1){             
          bunka = document.createElement("th");
          bunka.innerHTML = "Název";          
          bunka.dataset['id'] = "pop_pou_0";
          radek.appendChild(bunka);
          bunka = document.createElement("th");
          bunka.innerHTML = "Obrázky";
          bunka.setAttribute("colspan","6");
          radek.appendChild(bunka);
        }else{
            for(let x = 0; x< 7; x++){
                bunka = document.createElement("th");                   
                bunka.setAttribute('class','drop_popisky');
                if(this.razeni == 1)
                    bunka.dataset['id'] = "pop_poz_"+x;
                else{
                    if(x==0)        bunka.dataset['id'] = "pop_poz_0";
                    else            bunka.dataset['id'] = "pop_poz_"+(7-x);                         
                }
                    
                radek.appendChild(bunka);   
            }
        }
        tabulka.appendChild(radek);
        //telo
        for(let x = 0; x<3; x++){
            radek = document.createElement("tr");
            radek.setAttribute("id","radek"+x+"_pr"+this.obtiznost);
            bunka = document.createElement("th");
            if(this.obtiznost==1)
                bunka.innerHTML = this.navesti[this.tmp["indexy"][this.tmp["vypis"][x]]]["nazev"];
            else{
                bunka.setAttribute('class','drop_popisky');
                bunka.dataset['id'] = "pop_vec";
            }                
                
            radek.appendChild(bunka);
            if(x==0){   
                bunka = radek.insertCell();
                bunka.setAttribute("colspan","6");
                bunka.setAttribute("rowspan","3");
                bunka.setAttribute("id","tabulka_in_pr"+this.obtiznost);
            }    
            tabulka.appendChild(radek);        
        }
        let table_obal = document.getElementById('tabulka_'+this.obtiznost);
        table_obal.appendChild(tabulka);    
    }
    
    //funkce, ktera vytvori obsah tabulek, kam se pretahuji obrazky
    vypln_tab(){
        let radek, bunka;
        for(let x=0;x<3;x++){
          radek = document.getElementById("radek"+x+"_pr"+this.obtiznost);
          if(radek.childElementCount == 2)
            radek.deleteCell(1); 
          for(let i = 0; i < 6; i++){
            bunka = document.createElement("td");
            bunka.setAttribute('class','drop_pr'+this.obtiznost);
            if(this.obtiznost == 1 && this.razeni==1)
                bunka.dataset['id'] = this.navesti[this.tmp["indexy"][this.tmp["vypis"][x]]]["zkratka"]+""+(i+1); 
            else if(this.obtiznost == 1 && this.razeni==0)
                bunka.dataset['id'] = this.navesti[this.tmp["indexy"][this.tmp["vypis"][x]]]["zkratka"]+""+(6-i);          
            radek.appendChild(bunka);        
          }
        }
        
    }
    
    set_DD(pomoc=0){           
        if(this.obtiznost == 1){  
          jQuery(".drag_pr"+this.obtiznost).draggable({ revert: "invalid" });         
          this.set_drop('.drop_pr'+this.obtiznost);
        }else if(this.obtiznost == 2 && pomoc == 1){
            //tady se nastavi popisky
            jQuery(".drag_popisky").draggable({ revert: "invalid" });
            this.set_drop('.drop_popisky',1);
            this.set_drop('.drop_pr'+this.obtiznost,2);
        }
    }
    
    set_drop(co,pomoc = 0){
        var pocet_ok;
        if(this.obtiznost == 1) pocet_ok = 6;
        else if(this.obtiznost == 2 && pomoc == 1) pocet_ok = 10;
        else if(this.obtiznost == 2 && pomoc == 2) pocet_ok = 6;
        var obt_priklad = this.obtiznost-1;  
        var razeni = this.razeni;
        jQuery(co).droppable({
              drop: function( event, ui ){
                event.preventDefault();
                if(event.target.dataset['id'] != "")
                  if(ui.draggable[0].dataset['id'] == event.target.dataset['id']){
                    if(obt_priklad == 0)
                        vytvor_skore(1);
                    event.target.appendChild(ui.draggable[0]);
                    jQuery(ui.draggable[0]).draggable("destroy");
                    ui.draggable[0].removeAttribute("class");
                    ui.draggable[0].removeAttribute("style");
                    jQuery(event.target).droppable("destroy");
                    splneno[obt_priklad][ui.draggable[0].dataset['index']]++;
                    //nstavi hodnotu radku
                    if(obt_priklad == 1 && event.target.dataset['id'] == "pop_vec"){                         //PR prohod
                        var tpl_rodic = event.target.parentElement;
                        for(let x = 1;x<7;x++){
                            if(razeni==1)
                                tpl_rodic.children[x].dataset['id'] = ui.draggable[0].dataset['zkratka']+""+x;
                            else
                                tpl_rodic.children[x].dataset['id'] = ui.draggable[0].dataset['zkratka']+""+(7-x);
                        }
                    }
                    
                    if(splneno[obt_priklad][ui.draggable[0].dataset['index']] == pocet_ok){
                        print_modal("modal","ok");
                        if(pocet_ok == 10){
                            jQuery(".drag_pr2").draggable({ revert: "invalid" });                                              //PR PROHOD
                            print_modal('modal','neutr',"Bezva! Zkus nyní správně umístit všechny obrázky do buněk tabulky.");    
                        }
                    }                     
                  }else{
                    if(obt_priklad == 0)
                        vytvor_skore(-1);
                    jQuery(ui.draggable[0]).draggable({
                      revert: true
                    });
                  }
                }
            });
    }
    
    //skryva inputy pred generovanim zbytku nebo tabulky, jen pr2
    hide_inputs(){
        document.getElementById("inputy_"+this.obtiznost).style.display = "none";     
    }
       
    prohazej(co){
      let tmp_var, tmp_index;
      for(let x = 0; x<this.tmp[co].length; x++){
        tmp_index = Math.floor(Math.random()*this.tmp[co].length);
        tmp_var = this.tmp[co][tmp_index];
        this.tmp[co][tmp_index] = this.tmp[co][x]; 
        this.tmp[co][x] = tmp_var;   
      } 
    } 
    
}

class tab_3 extends navrh_tabulky{
    constructor(obtiznost){
    super(obtiznost);
        
    this.navesti = new Array(5);
    this.navesti[0] = {"zkratka": "afr", "nazev": "Africká", "soubor": "africke"};
    this.navesti[1] = {"zkratka": "dom", "nazev": "Domácí", "soubor": "domaci"};
    this.navesti[2] = {"zkratka": "hos", "nazev": "Hospodářská", "soubor": "hospodarska"};
    this.navesti[3] = {"zkratka": "les", "nazev": "Lesní", "soubor": "lesni"};
    this.navesti[4] = {"zkratka": "ros", "nazev": "Rostliny", "soubor": "rostliny"};
    
    this.tmp = new Array(4);
    this.tmp["indexy"] = new Array(3);              //pomocna promenna urcujici typ obrazku             
    this.tmp["obrazky"] = new Array(3);             //pomocna promenna urcujici barvu obrazku
    this.tmp["vypis"] = [0,1,2];                    //pomocna promennna urcujici vypisovani hromadek 
    this.tmp["barvy"] = ["Oranžová b.","Azurová b.","Modrá b.","Žlutá b."];                    //barvy
    
    let cislo;
    var tmp_i = 0;  
    
      while(tmp_i<3){
          cislo = Math.floor(Math.random() * (+4 - +0)) + +0;
          if(!this.tmp["obrazky"].includes(cislo)){
              this.tmp["obrazky"][tmp_i] = cislo;
              tmp_i++;
          }    
      }
      
      tmp_i = 0;  
      while(tmp_i<3){
          cislo = Math.floor(Math.random() * (+4 - +0)) + +0;                     //5 - bere to i rostliny
          if(!this.tmp["indexy"].includes(cislo)){
              this.tmp["indexy"][tmp_i] = cislo;
              tmp_i++;
          }    
      }

    }
    
    //slo by to zase rozvetvit pomoci ifu, ale at to neni neprehledne, tak pr_3 radsi udelam samostatne
    makeStructure(){
        let popis_div = document.createElement("div");
        popis_div.setAttribute("id","popis_"+this.obtiznost);
        let popis = document.createElement("p");  
        popis.innerHTML = "Tentokrát budeš vytvářet tabulku pro&nbsp;3&nbsp;druhy zvířat ve&nbsp;3&nbsp;barvách. Nejprve urči počet potřebných řádků a&nbsp;sloupců, pak&nbsp;vyplň záhlaví (řádků i sloupců) tabulky. Buď v&nbsp;pohodě, na&nbsp;pořadí barev ani&nbsp;druhů zvířat v&nbsp;záhlaví (řádků ani sloupců) tabulky nezáleží. <br> Nakonec se&nbsp;pusť do&nbsp;vyplňování tabulky obrázky. Tak&nbsp;do&nbsp;toho!";
        popis_div.appendChild(popis); 
        this.rodic.appendChild(popis_div);
    
        //div s tabulkou
        let obsah_obal = document.createElement("div");
        obsah_obal.classList.add("w3-row");
        
        let tabulka = document.createElement("div");
        tabulka.setAttribute("id","tabulka_"+this.obtiznost);
        tabulka.classList.add("w3-threequarter");
        
        let vyber_obr = document.createElement("div");
        vyber_obr.setAttribute("id","vyb_obr_"+this.obtiznost); 
        vyber_obr.classList.add("w3-quarter");  
        
        //popisky tabulky
        let vyber_popisky = document.createElement("div");
        vyber_popisky.setAttribute("id","inputy_"+this.obtiznost);
        tabulka.appendChild(vyber_popisky);
                                                                                                                     
        obsah_obal.appendChild(tabulka);
        obsah_obal.appendChild(vyber_obr);
        this.rodic.appendChild(obsah_obal);
    }
    
    vytvor_tabulku(){
        let radek, bunka;
        let tabulka = document.createElement("table");
        tabulka.setAttribute("id","evidujeme_pr"+this.obtiznost); 
        tabulka.classList.add("navrh_tabulky");
        //"hlava"
        radek = document.createElement("tr");
        for(let x = 0; x<4; x++){
            
            bunka = document.createElement("th");
            if(x != 0){
              bunka.classList.add('drop_pr'+this.obtiznost,'pr'+this.obtiznost+'_sloupec');
              bunka.dataset["tmp_kam"] = x;
            }       
            radek.appendChild(bunka);   
        }         
        tabulka.appendChild(radek);
        //telo
        for(let x = 0; x<3; x++){
            radek = document.createElement("tr");
            radek.setAttribute("id","radek"+x+"_pr"+this.obtiznost);
            bunka = document.createElement("th");
            bunka.classList.add('drop_pr'+this.obtiznost,'pr'+this.obtiznost+'_radek'); 
            bunka.dataset["tmp_kam"] = x;
            radek.appendChild(bunka);
            for(let v = 0; v < 3; v++){
                bunka = document.createElement("td");
                bunka.classList.add('drop_pr'+this.obtiznost+'_in');       
                radek.appendChild(bunka);
            }
            tabulka.appendChild(radek);        
        }
        let table_obal = document.getElementById('tabulka_'+this.obtiznost);
        table_obal.appendChild(tabulka);   
    }
        
    vytvor_hromadky(pocet){
      let obal, element;
      let rodic = document.getElementById('vyb_obr_'+this.obtiznost);
      rodic.innerHTML = "";
      for(let i=0; i<pocet; i++){
        obal = document.createElement('div');
        this.prohazej('vypis');                                             
        for(let x=0;x<3;x++){
          element = document.createElement('img');
          element.src = this.prefix+"/"+this.navesti[this.tmp["indexy"][i]]["soubor"]+"/"+this.navesti[this.tmp["indexy"][i]]["zkratka"]+""+(this.tmp["obrazky"][this.tmp["vypis"][x]]+1)+".png";
          element.dataset['barva'] = this.tmp["obrazky"][this.tmp["vypis"][x]];
          element.dataset['zvire'] = this.tmp["indexy"][i];
          element.setAttribute("class","drag_pr"+this.obtiznost+"_2");
          obal.appendChild(element);
        }
        rodic.appendChild(obal);        
      }  
    }
    
    vytvor_popisky(){
        let vyber = document.createElement("div");
        vyber.setAttribute("id","vyber_pr"+this.obtiznost);
        vyber.classList.add("vyber_pr"+this.obtiznost);
        let umisteni = document.getElementById("tabulka_"+this.obtiznost);
        let span_ob;
        //barvy
        for(let i=0;i<3;i++){
            span_ob = document.createElement("span");  
            span_ob.classList.add("drag_pr"+this.obtiznost);
            span_ob.dataset['id'] = "barva";  
            span_ob.dataset['index'] = 0;   
            span_ob.dataset['pom'] = this.tmp["obrazky"][i];    
            span_ob.innerHTML = this.tmp["barvy"][this.tmp["obrazky"][i]];
            vyber.appendChild(span_ob);
        }
        //zvirata
        for(let i=0;i<3;i++){
            span_ob = document.createElement("span");
            span_ob.innerHTML = this.navesti[this.tmp["indexy"][this.tmp["vypis"][i]]]["nazev"];            
            span_ob.classList.add("drag_pr"+this.obtiznost);
            span_ob.dataset['id'] = "zvire";    
            //span_ob.dataset['zkratka'] = this.navesti[this.tmp["indexy"][this.tmp["vypis"][i]]]["zkratka"];    
            span_ob.dataset['index'] = 1;
            span_ob.dataset['pom'] = this.tmp["indexy"][this.tmp["vypis"][i]]; 
            vyber.appendChild(span_ob);
        }                       
        umisteni.appendChild(vyber);  
        
        //odkryju taky rovnou obrazy, co se budo pretahovat
       // let rodic_ob = document.getElementById('vyb_obr_2');
        //rodic_ob.style.display = "block";   
    }
    
    vytvor_inputy(){
        super.vytvor_inputy();   
    }
       
    set_DD(){
        var tmp_obtiznost = this.obtiznost;
        jQuery(".drag_pr"+tmp_obtiznost).draggable({ revert: "invalid" });
        jQuery(".drop_pr"+tmp_obtiznost).droppable({             
             drop: function( event, ui ){             
                event.preventDefault(); 
                //prvni drop urci radek/sloupec
                //zbytek prvku pro hlavicku - sedi idcka? 
                if(event.target.classList.contains("drop_pr"+tmp_obtiznost))
                if(ui.draggable[0].dataset['id'] == event.target.dataset['id']){
                    event.target.appendChild(ui.draggable[0]);
                    jQuery(ui.draggable[0]).draggable("destroy");
                    ui.draggable[0].removeAttribute("class");
                    ui.draggable[0].removeAttribute("style");
                    jQuery(event.target).droppable("destroy"); 
                    splneno[2][0]++;
                    priprav_data(ui.draggable[0], event.target.dataset["tmp_kam"], event.target.dataset["trida"]);      
                    if(splneno[2][0] == 6){
                        jQuery(".drag_pr"+tmp_obtiznost+"_2").draggable({ revert: "invalid" });
                        print_modal('modal','neutr',"Bezva! Zkus nyní správně umístit všechny obrázky do buněk tabulky.");
                    }                         
                }else{
                  if(ui.draggable[0].dataset['index'] == 0 && event.target.classList.contains('pr'+tmp_obtiznost+'_radek') && tmp_pomocna[0] == 0){
                    //do radku dava barvy  
                    prvni_drop(0, "pr"+tmp_obtiznost+"_radek", event.target, ui.draggable[0]);
                    splneno[2][0]++;
                  }else if(ui.draggable[0].dataset['index'] == 1 && event.target.classList.contains('pr'+tmp_obtiznost+'_radek') && tmp_pomocna[1] == 0){
                    //do radku dava zvire   
                    prvni_drop(1, "pr"+tmp_obtiznost+"_radek", event.target, ui.draggable[0]);   
                    splneno[2][0]++;
                  }else if(ui.draggable[0].dataset['index'] == 0 && event.target.classList.contains('pr'+tmp_obtiznost+'_sloupec') && tmp_pomocna[0] == 0){
                    //do sloupce dava barvy
                    prvni_drop(0, "pr"+tmp_obtiznost+"_sloupec", event.target, ui.draggable[0]); 
                    splneno[2][0]++;
                  }else if(ui.draggable[0].dataset['index'] == 1 && event.target.classList.contains('pr'+tmp_obtiznost+'_sloupec') && tmp_pomocna[1] == 0){
                    //do sloupce dava zvire
                    prvni_drop(1, "pr"+tmp_obtiznost+"_sloupec", event.target, ui.draggable[0]); 
                    splneno[2][0]++;  
                  }else{
                      jQuery(ui.draggable[0]).draggable({
                        revert: true
                      });
                  }
                }
            }
        });
        
      //vnitrek tabulky        
      jQuery(".drop_pr"+tmp_obtiznost+"_in").droppable({
          drop: function( event, ui ){             
              event.preventDefault();
              if(ui.draggable[0].dataset['barva'] == event.target.dataset['barva'] && ui.draggable[0].dataset['zvire'] == event.target.dataset['zvire'] &&
                  event.target.hasAttribute("data-zvire") && event.target.hasAttribute("data-barva")){
                  event.target.appendChild(ui.draggable[0]);
                  jQuery(ui.draggable[0]).draggable("destroy");
                  ui.draggable[0].removeAttribute("class");
                  ui.draggable[0].removeAttribute("style");
                  jQuery(event.target).droppable("destroy"); 
                  splneno[2][1]++;  
                  if(splneno[2][1] == 9){
                      print_modal('modal','ok');
                  }
              }else{
                  jQuery(ui.draggable[0]).draggable({
                      revert: true
                  });
              }   
          }
      });       
    }     
}

var pr_1 = new navrh_tabulky(1);
pr_1.makeStructure();  
pr_1.prohazej('indexy');
pr_1.vytvor_hromadky(3);  
pr_1.prohazej("vypis");
pr_1.priprav_tab();       
pr_1.vytvor_inputy(3);


var pr_2 = new navrh_tabulky(2);
pr_2.makeStructure();
pr_2.prohazej('indexy');
pr_2.vytvor_hromadky(3);
pr_2.vytvor_inputy(3);


var pr_3 = new tab_3(3); 
pr_3.makeStructure();    
pr_3.vytvor_tabulku();
pr_3.vytvor_hromadky(3); 
pr_3.vytvor_popisky();
prohazej('drag_pr3','vyber_pr3'); 
pr_3.set_DD();  
pr_3.vytvor_inputy();

//generovani tabulky po kliknuti
function vytvor_tabulku(obtiznost){
    let sloupce = document.getElementById("sloupce_"+obtiznost).value;
    let radky = document.getElementById("radky_"+obtiznost).value;
    if(sloupce == 6 && radky == 3 && obtiznost == 1){
        //ok pr1 - doplni se tabulka
        pr_1.vypln_tab()   
        print_modal('modal','neutr',"Bezva! Zkus nyní správně umístit všechny obrázky do buněk tabulky.");
        pr_1.set_DD();
        vytvor_skore(0);
    }else if(sloupce == 7 && radky == 4 && obtiznost == 2){
        //ok pr2 - vytvori se tabulka
        pr_2.priprav_tab();
        pr_2.hide_inputs();
        pr_2.vypln_tab();   
        print_modal('modal','neutr',"Bezva! Zkus nyní správně vyplnit záhlaví tabulky.");
        pr_2.vytvor_popisky();
        prohazej('drag_popisky','vyber_pr2');
        pr_2.set_DD(1);
    }else if(sloupce == 4 && radky == 4 && obtiznost == 3){
        document.getElementById("evidujeme_pr3").style.display = "inline-table";
        document.getElementById("vyber_pr3").style.display = "block";
        document.getElementById("vyb_obr_3").style.display = "block";
        print_modal('modal','neutr',"Bezva! Zkus nyní správně vyplnit záhlaví tabulky.");
        document.getElementById("inputy_3").style.display = "none";         
    }else{
        //nok - informuje se o chybe
        let chyba; 
        if((obtiznost == 2 && (sloupce == 6 || radky == 3)) || ((obtiznost == 3 && (sloupce == 3 || radky == 3))))
            chyba = "To není úplně správně. Nezapomněl jsi na to, že tabulka musí mít záhlaví buněk?";
        else if((obtiznost == 2 && radky != 4 && sloupce != 7) || (obtiznost == 1 && radky !=3 && sloupce != 6) || (obtiznost == 3 && radky !=4 && sloupce != 4))
            chyba = "Kdepak, zkontroluj si ještě údaje pro řádky i sloupečky.";
        else if((obtiznost == 2 && sloupce != 7) || (obtiznost == 1 && sloupce !=6) || ((obtiznost == 3 && sloupce !=4)))
            chyba = "Ten počet sloupečků se mi nějak nezdá. Zkus to ještě!";
        else if((obtiznost == 2 && radky != 4) || (obtiznost == 1 && radky !=3) || (obtiznost == 3 && radky != 4))
            chyba = "Ten počet řádků se mi nějak nezdá. Zkus to ještě!";  
        print_modal('modal','neutr',chyba);
    }
}

//vyrvri tabulku s vypsnými pokusy (jen pro pr1)
function vytvor_skore(indikator){
    if(indikator == 0){
    //tvorba
    let texty = ["Chybné pokusy: ", "Správně umístěno: "]
    let table = document.createElement("table");
    let bunka, radek, popis, skore;
    radek = table.insertRow(0);
    for(let x = 0; x<2; x++){
        skore = document.createElement("span");
        skore.setAttribute("id","skore_"+x);
        skore.innerHTML = pokusy[x];
        bunka = radek.insertCell(0)
        bunka.innerHTML = texty[x];
        bunka.appendChild(skore);    
    }
    document.getElementById('tabulka_1').appendChild(table);     
    }else{
    //uprava skore
        if(indikator == 1){
            pokusy[1]++;
            document.getElementById("skore_1").innerHTML = pokusy[1];    
        }else{
            pokusy[0]++;
            document.getElementById("skore_0").innerHTML = pokusy[0];  
        }
    }        
}


//musim to dat mimo tridu, pac tam "nedosahne drop"
function prvni_drop(index, trida, kam, co){
    tmp_pomocna[index] = 1;
    var prvky = document.getElementsByClassName(trida);
    for(let x=3;x>0;x--){
        prvky[0].dataset["id"]=co.dataset["id"];    
        prvky[0].dataset["trida"] = trida;
        prvky[0].classList.remove(trida);
    }
    kam.appendChild(co);  
    //jQuery(co).draggable("destroy");
    co.removeAttribute("class");
    co.removeAttribute("style"); 
    kam.removeAttribute("class");   
    
    priprav_data(co,kam.dataset["tmp_kam"],trida);     
}
//tohle je spatne!
function priprav_data(co,kam,trida){
    //priprava pro ostatni
    let tmp_index = parseInt(co.dataset["pom"]);
    if(trida == "pr3_radek"){
        //vyberu radek a upravi dataset
        let radek = document.getElementById("radek"+kam+"_pr3");
        for(let x=1;x<4;x++){
            radek.cells[x].dataset[co.dataset["id"]] = tmp_index;
        }
    }else{
        //vyberu vsechny radky a upravim urcite bunky
        let prvek;
        for(let x = 0; x<3; x++){
            prvek = document.getElementById("radek"+x+"_pr3");
            prvek.cells[kam].dataset[co.dataset["id"]] = tmp_index;    
        }
    }

}